/*******************************************************************************/
/*****	Methods		************************************************************/
/*******************************************************************************/

METHOD sie_set
{
	LABEL		[transfer];
	HELP		[transfer_help];
	CLASS		INPUT;
	DEFINITION
	{
	}
}

METHOD polling_address_set
{
	LABEL		[transfer];
	HELP		[transfer_help];
	CLASS		INPUT;
	DEFINITION
	{
		ACKNOWLEDGE([message_polling_address]);
	}
}

/*******************************************************************************/
/*****	MENU Bar  **************************************************************/
/*******************************************************************************/

MENU Menu_Main_Specialist
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		/*Menu_Edit,*/
		Menu_S_Device,
		Menu_View,
		Menu_Options,
		Menu_Help
	}
}

MENU Menu_Main_Maintenance
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_M_Device,
		Menu_View,
		Menu_Options,
		Menu_Help
	}
}

/*---------------------------------------------------------------------*/
/*    Menu: File													   */
/*---------------------------------------------------------------------*/

#include "SI_FileM.inc"

/*---------------------------------------------------------------------*/
/*    MENU: Device													   */
/*---------------------------------------------------------------------*/

MENU Menu_S_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
			std_CommWay,
//			SEPARATOR,
//			OnlineDialog_Device_NodeAddress,
			SEPARATOR,
			std_LoadinDevice,
			std_LoadinPC,
			SEPARATOR,
//	OnlineDialog_selftest,
			OnlineDialog_simulation,
			SEPARATOR,
			reset_totalizer_method,
			reset_device_method,
			SEPARATOR,
			OnlineDialog_zero_trim,
			OnlineDialog_calibration,
                        OnlineDialog_DAC_trim, //dac_trim,
			SEPARATOR,
			OnlineDialog_direct_access,
			SEPARATOR,
			//loop_test,
			reset_change_flag_method,//OnlineDialog_reset_change_flag,
			OnlineDialog_hart_comm
	}
}

MENU Menu_M_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
			std_CommWay,
//			SEPARATOR,
//			OnlineDialog_Device_NodeAddress,
			SEPARATOR,
			std_LoadinDevice,
			std_LoadinPC,
			SEPARATOR,
//	OnlineDialog_selftest,
			OnlineDialog_simulation,
//			SEPARATOR,
//			reset_totalizer_method,
//			reset_device_method,
//			SEPARATOR,
//			OnlineDialog_zero_trim,
//			OnlineDialog_calibration,
//                        OnlineDialog_DAC_trim, //dac_trim,
//			SEPARATOR,
//			OnlineDialog_direct_access,
//			SEPARATOR,
			//loop_test,
//			reset_change_flag_method,//OnlineDialog_reset_change_flag,
//			OnlineDialog_hart_comm
	}
}

METHOD std_CommWay
{
	LABEL		[menu_Device_CommWay];
	DEFINITION
	{
	}
}

METHOD std_LoadinDevice
{
	LABEL		[menu_Device_LoadinDevice];
	DEFINITION
	{
	}
}

METHOD std_LoadinPC
{
	LABEL		[menu_Device_LoadinPC];
	DEFINITION
	{
	}
}

/*---------------------------------------------------------------------*/
/*    MENU: View													   */
/*---------------------------------------------------------------------*/

MENU Menu_View
{
	LABEL		[menu_View];
	ITEMS
	{
			OnlineWindow_display,
			OnlineWindow_yt,
			OnlineWindow_diagnosis,
			SEPARATOR,
			std_Funktionsleiste,
			std_Statuszeile,
			SEPARATOR,
			std_Update
	}
}

METHOD std_Funktionsleiste
{
	LABEL		[menu_View_Toolbar];
	DEFINITION
	{
	}
}

METHOD std_Statuszeile
{
	LABEL		[menu_View_Statusbar];
	DEFINITION
	{
	}
}

METHOD std_Update
{
	LABEL		[menu_View_Update];
	DEFINITION
	{
	}
}


/*---------------------------------------------------------------------*/
/*    MENU: Options													   */
/*---------------------------------------------------------------------*/

#include "SI_OptM.inc"

/*---------------------------------------------------------------------*/
/*    MENU: Help													   */
/*---------------------------------------------------------------------*/

#include "SI_HlpM.inc"

/*******************************************************************************/
/*****	Online-Windows  ********************************************************/
/*******************************************************************************/

MENU OnlineWindow_display
{
	LABEL		[menu_dialog_display];
	ITEMS
	{
		Page_flow_display
		Page_display_out_tot
		//Page_debug_display
	}
}

MENU Page_display_overview
{
	LABEL	[menu_dialog_overview];
	ITEMS
	{
		BarVal_process_flow_display,
		Val_total_totalizer,
		Val_analog_value,
		device_status(READ_ONLY)
	}
}

MENU Val_total_totalizer
{
    LABEL       "counter|de|Zhler";
	HELP			"Totalizer is not resetable directly. It can be forced while changing the unit";
	ITEMS
	{
        totl_value//total_totalizer
	}

}

MENU Val_analog_value
{
    LABEL           [analog_output_value];
	ITEMS
	{
		flow_rate.ANALOG_VALUE
	}
}

MENU Val_input_percent_range
{
    LABEL           [percent_of_range];
	ITEMS
	{
		flow_rate.PERCENT_RANGE
	}
}

MENU Page_flow_display
{
	LABEL		[menu_dialog_display_measure];
	ITEMS
	{
			BarVal_process_flow_display,
			Val_input_percent_range,
			Val_analog_value,
			device_status				(READ_ONLY)
	}
}

MENU BarVal_process_flow_display
{
	LABEL		[menu_dialog_display_measure];
	ITEMS
	{
			flow_rate.DIGITAL_VALUE,
			flow_rate.LOWER_RANGE_VALUE	(READ_ONLY),
			flow_rate.UPPER_RANGE_VALUE	(READ_ONLY)

	}
}

MENU Page_display_out_tot
{
	LABEL  "counter|de|Zhler";
	ITEMS
	{
		Val_total_totalizer,
		//reset_totalizer_method
	}
}

/*MENU Page_debug_display
{
	LABEL		"raw values" "|de|Rohwerte";
	ITEMS
	{
		Group_sv_tv_qv_display
	}
}*/





MENU OnlineWindow_diagnosis
{
	LABEL		[menu_dialog_diagnosis];
	ITEMS
	{
		Page_diagnosis_device,
		Page_diagnosis_status,
	}
}

MENU Page_diagnosis_device
{
	LABEL		[menu_ident_device];
	ITEMS
	{
			tag (READ_ONLY),
			manufacturer_id(READ_ONLY),
			device_id(READ_ONLY),
			device_type(READ_ONLY),
			date(READ_ONLY),
			universal_revision(READ_ONLY),
			transmitter_revision(READ_ONLY),
			//hardware_revision(READ_ONLY),
			software_revision(READ_ONLY),
			sensor_serial_number(READ_ONLY),
			final_assembly_number(READ_ONLY),

	}
}

MENU Page_diagnosis_status
{
	LABEL	[menu_status];
	ITEMS
	{
		Group_device_status,
		Group_diagnosis
	}
}

MENU Group_device_status
{
	LABEL  "Device status""|de|Gerte-Status";
	ITEMS
	{
		device_status		(READ_ONLY),
		reset_changed_flag,
		show_counterpara_change
	}
}

MENU Group_diagnosis
{
	LABEL  [menu_diagnosis];
	ITEMS
	{
		xmtr_specific_status_0 (DISPLAY_VALUE),		/* var */
		xmtr_specific_status_1 (DISPLAY_VALUE)		/* var */
	}
}

/*******************************************************************************/
/*****	Online-Dialogs  ********************************************************/
/*******************************************************************************/

MENU OnlineDialog_zero_trim
{
	LABEL  [menu_zero_trim];
	ITEMS
	{
		Page_zero_trim
	}
}

MENU OnlineDialog_calibration
{
	LABEL  "wet calibration|de|Nakalibrierung";
	ITEMS
	{
		Page_kennlinie,
		Page_wet_calibrate
	}
}

MENU OnlineDialog_DAC_trim
  {
	LABEL "trim current output|de|Stromausgang kalibrieren";
	ITEMS
	{
        dac_trim
	}
  }

MENU OnlineDialog_direct_access
{
	LABEL  "Direct access""|de|Direktzugriff";
	ITEMS
	{
		Page_direct_access
	}
}

//MENU OnlineDialog_selftest
//{
//	LABEL  [selftest];
//	ITEMS
//	{
//		Page_selftest
//	}
//}

MENU OnlineDialog_simulation
{
	LABEL  [menu_interface_simulate];
	ITEMS
	{
		Page_simulation
	}
}

MENU OnlineDialog_reset_change_flag
{
	LABEL  [configuration_flag_reset];
	ITEMS
	{
		Page_reset_change_flag
	}
}
MENU OnlineDialog_operating_modes_menu
{
	LABEL  "Operating modes""|de|Betriebsarten";
	ITEMS
	{
		operating_modes_menu
	}
}

MENU OnlineDialog_hart_comm
{
	LABEL		[menu_HART_Comm];
	ITEMS
	{
			Page_request_response_preambles
	}
}

MENU Page_request_response_preambles
{
	LABEL		[menu_request_response_preambles];
	ITEMS
	{
			response_preambles ,
			request_preambles ,
			sie_set
	}
}

MENU OnlineDialog_Device_NodeAddress
{
	LABEL		[menu_Device_NodeAddress];
	ITEMS
	{
			polling_address,
			polling_address_set
	}
}

/*******************************************************************************/
/*****	Upload / Download MENU  ************************************************/
/*******************************************************************************/
MENU upload_variables  /* schreiben in Feldgrt */
{
	LABEL		[menu_load_to_device];

	PRE_WRITE_ACTIONS
	{
method_write_self_test
	}
	POST_WRITE_ACTIONS
	{
burn_eeprom
//		save_calibration_method
	}
	ITEMS
	{
		tag,
		date,
		descriptor,
		message,
		flow_damping_value,
		flow_units,
		calibrate_end_value,
		flow_upper_range_value,
		totalizer_switch,
		volume_flow_cutoff,
		para_maxlimit,
		para_minlimit,
		para_output_status,
		namur_switch,

		//Selbsttest
		// for future
		self_test_Qrel,
		self_test_delta,
		self_test_period,
		floatmvment,
self_test_mask_1,
/*		local_self_test_mask_1_01,
		local_self_test_mask_1_02,
		local_self_test_mask_1_04,
		local_self_test_mask_1_08,
		local_self_test_mask_1_10,
		local_self_test_mask_1_20,*/
		current_output_alarm,


		calibrate_number_of_point,
		//calibrate_unit,
		Atara,
		Btara,
		Amax,
		Bmax,
		Qrel_Value_00,
		Qrel_Value_01,
		Qrel_Value_02,
		Qrel_Value_03,
		Qrel_Value_04,
		Qrel_Value_05,
		Qrel_Value_06,
		Qrel_Value_07,
		Qrel_Value_08,
		Qrel_Value_09,
		Qrel_Value_10,
		Qrel_Value_11,
		Qrel_Value_12,
		Qrel_Value_13,
		Qrel_Value_14,
		Qrel_Value_15,
		A_B_Value_00,
		A_B_Value_01,
		A_B_Value_02,
		A_B_Value_03,
		A_B_Value_04,
		A_B_Value_05,
		A_B_Value_06,
		A_B_Value_07,
		A_B_Value_08,
		A_B_Value_09,
		A_B_Value_10,
		A_B_Value_11,
		A_B_Value_12,
		A_B_Value_13,
		A_B_Value_14,
		A_B_Value_15
	}
}

MENU download_variables  /* lesen aus Feldgert */
{
    LABEL   [menu_load_to_PC];

    ITEMS
    {
manufacturer_id,
		private_label_distributor,
		device_type,
		device_id,
		tag,
		date,
		write_protect,
		descriptor,
		message,
		final_assembly_number,
		universal_revision,
		transmitter_revision,
		software_revision,
		flow_damping_value,
		flow_units,
		transfer_function,
		totl_units,
		flow_upper_sensor_limit,
		flow_lower_sensor_limit,
		flow_minimum_span,
		flow_upper_range_value,
		flow_lower_range_value,
		totalizer_switch,
		volume_flow_cutoff,
		para_maxlimit,
		para_minlimit,
		para_output_status,
		namur_switch,

		//Selbsttest
		// for future
		self_test_Qrel,
		self_test_delta,
		self_test_period,
		floatmvment,
		self_test_mask_1,//??? (READ_ONLY),
/*method_read_self_test_mask_1,
		local_self_test_mask_1_01,
		local_self_test_mask_1_02,
		local_self_test_mask_1_04,
		local_self_test_mask_1_08,
		local_self_test_mask_1_10,
		local_self_test_mask_1_20,*/
		current_output_alarm,


		calibrate_number_of_point,
		//calibrate_unit,
		calibrate_end_value,
		Atara,
		Btara,
		Amax,
		Bmax,
		Qrel_Value_00,
		Qrel_Value_01,
		Qrel_Value_02,
		Qrel_Value_03,
		Qrel_Value_04,
		Qrel_Value_05,
		Qrel_Value_06,
		Qrel_Value_07,
		Qrel_Value_08,
		Qrel_Value_09,
		Qrel_Value_10,
		Qrel_Value_11,
		Qrel_Value_12,
		Qrel_Value_13,
		Qrel_Value_14,
		Qrel_Value_15,
		A_B_Value_00,
		A_B_Value_01,
		A_B_Value_02,
		A_B_Value_03,
		A_B_Value_04,
		A_B_Value_05,
		A_B_Value_06,
		A_B_Value_07,
		A_B_Value_08,
		A_B_Value_09,
		A_B_Value_10,
		A_B_Value_11,
		A_B_Value_12,
		A_B_Value_13,
		A_B_Value_14,
		A_B_Value_15,

    }
}

